ChiliProject - Bug # 527: pulling garbage revisions from github

Status: Closed Priority: Normal

Author: Toshi MARUYAMA Category: chiliproject.org Website
Created: 2011-07-15 Assignee:

Updated: 2011-12-18 Due date:

Remote issue URL:
Affected version:
Description: For example.
GitHub Merge Button commit:d64b022f

* github merge button leaves extra clutter "heads"
https://github.com/schacon/hg-git/issues/219

* pulling garbage revisions from github
https://github.com/schacon/hg-git/issues/217

<pre>
$ git remote -v

chili git://github.com/chiliproject/chiliproject.git (fetch)
chili git://github.com/chiliproject/chiliproject.git (push)

$ git Is-remote chili
dd6d9d1c680f1bd0026372c392685b6c6070fa0bl HEAD
dd6d9d1c680f1bd0026372c39a685b6¢c6070fa0bl refs/heads/master
effcd726a39b28f3dea5fca63aabe5f7d4635¢5f0 refs/heads/stable
ddeb1a2a0f10db7e37f7bbdadbd22a194a5893200 refs/heads/unstable
b576ace2cad8510ad20b89103bb999b6b34e9f680 refs/pull/1/head
271aafc001e106845a5a2fch45c5461fdaae61360 refs/pull/10/head
f502ea16887296¢f1735d498872ed084881222600 refs/pull/11/head
4dffc45ee96d0fe893264db56aa1a3bal4b0ctb8l refs/pull/12/head
d0591d46e8773e1a5ce88bf45cdf42a0549765820 refs/pull/13/head
da45dfcc72b5a4235e9c1edb8f62364f026dd068L refs/pull/14/head
530951dd43adf2475767e0135f0e8cce914692d8L refs/pull/15/head

</pre>

Associated revisions

2008-02-16 02:19 pm - Jean-Philippe Lang
Added the following permissions (#527, #585, #627):
* edit_issue_notes: let user edit any notes

* edit_own_issue_notes: let user edit his own notes only

git-svn-id: http://redmine.rubyforge.org/svn/trunk@1152 e93f8b46-1217-0410-a6f0-8f06a7374b81

History

2011-07-16 08:13 am - Felix Schéfer

We've already contacted github about the same problem, for example commit:5b7508baadfac2abc0148ac5cd3f1dd8309b1e71 shows up here, it shows
up on "github in chiliproject/chiliproject":https://github.com/chiliproject/chiliproject/commit/5b7508baadfac2abc0148ac5cd3f1dd8309b1e71 if you know
the hash, it's part of "pull request 82":https://github.com/chiliproject/chiliproject/pull/82, but it doesn't show on any branch in our repo on github or here
for that matter.

Github's answer was: "This is a side effect of how we store pull requests for public repo networks. Private repos handle them differently to avoid that
exact problem. If you're using --mirror you'll want to prune out the pull request branches afterwards."

In other words, we can't use @git --mirror@ or anything related on github public repos without it being polluted by pull request branches, which sucks.
Holger proposed a fix to that (use @git fetch --all --tags --prune@ instead), but I'm not sure if anyone's changed the cronjob already.

2011-07-16 08:24 am - Holger Just

Felix SchArfer wrote:

> I'm not sure if anyone's changed the cronjob already.

Nope. The repo would have to be re-created to purge the existing commits and to remove them from cp.o's database. Also note that @git fetch ...@
just pulls new changesets but doesn't touch existing commits in the repo.

| think, the more correct solution in the long run would be to only handle commits inside @refs/heads@ and @refs/tags@ and ignore all the others.

However from the top of my head | don't know how to do it. Would need to investigate...

2011-07-17 10:20 pm - Toshi MARUYAMA
hg-git fixed this problem.
https://github.com/schacon/hg-git/pull/223

2011-12-18 06:19 pm - Holger Just
- Status changed from Open to Closed

The issue should get fixed by not using @--mirror@. Thus closing in favor of #675.
